///--------------------------------------------------------------------------------------
//	Scrolling.h
//
//	By: Vern Jensen 8/29/95
///--------------------------------------------------------------------------------------


#ifndef __SCROLLING__
#define __SCROLLING__



///--------------------------------------------------------------------------------------
//	scrolling function prototypes
///--------------------------------------------------------------------------------------


#ifdef __cplusplus
extern "C" {
#endif


SW_FUNC void SWUpdateScrollingWindow(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWUpdateScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP,
	Boolean updateWindow);

SW_FUNC void SWProcessScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWAnimateScrollingSpriteWorld(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWDrawWrappedSprite(
	SpritePtr srcSpriteP,
	FramePtr dstFrameP,
	Rect* srcRect,
	Rect* dstRect);

SW_FUNC void SWEraseWrappedSprite(
	SpriteWorldPtr spriteWorldP,
	Rect* dstRect);

SW_FUNC void SWWrapWorldToScreen(
	SpriteWorldPtr	spriteWorldP);

SW_FUNC void SWCheckWrappedIdleSpriteOverlap(
	SpriteWorldPtr			spriteWorldP,
	register SpritePtr		idleSpriteP,
	SpritePtr				headActiveSpriteP);

SW_FUNC void SWRedrawErasedIdleSprites(
	SpriteWorldPtr	spriteWorldP,
	SpritePtr		headActiveSpriteP,
	SpritePtr		headIdleSpriteP);

SW_FUNC void SWRedrawIdleSpritesInRect(
	SpriteWorldPtr	spriteWorldP,
	SpritePtr		headIdleSpriteP,
	Rect			*updateRect);

SW_FUNC void SWSetScrollingWorldMoveBounds(
	SpriteWorldPtr	spriteWorldP,
	Rect* scrollRectMoveBounds);

SW_FUNC void SWSetScrollingWorldMoveProc(
	SpriteWorldPtr spriteWorldP, 
	WorldMoveProcPtr worldMoveProcP, 
	SpritePtr followSpriteP);

SW_FUNC void SWSetSpriteWorldScrollDelta(
	SpriteWorldPtr	spriteWorldP,
	short			horizDelta,
	short			vertDelta);

SW_FUNC void SWMoveVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizPos,
	short			vertPos);

SW_FUNC void SWOffsetVisScrollRect(
	SpriteWorldPtr	spriteWorldP,
	short			horizOffset,
	short			vertOffset);

SW_FUNC void SWCalculateOffscreenScrollRect(
	SpriteWorldPtr spriteWorldP);


#ifdef __cplusplus
}
#endif

#endif /* __SCROLLING__ */