///--------------------------------------------------------------------------------------
//	Tiling.h
//
//	By: Vern Jensen 10/27/95
///--------------------------------------------------------------------------------------


#ifndef __TILING__
#define __TILING__


///--------------------------------------------------------------------------------------
//	define the TileMapPtr
///--------------------------------------------------------------------------------------

typedef short** TileMapPtr;

typedef SW_FUNC void (*TileChangeProcPtr)(
	SpriteWorldPtr spriteWorldP);

///--------------------------------------------------------------------------------------
//	tile function prototypes
///--------------------------------------------------------------------------------------


#ifdef __cplusplus
extern "C" {
#endif


SW_FUNC OSErr SWInitTiling(
	SpriteWorldPtr	spriteWorldP,
	short 			tileHeight,
	short			tileWidth,
	short			maxNumTiles);

SW_FUNC void SWExitTiling(
	SpriteWorldPtr	spriteWorldP);

SW_FUNC OSErr SWCreateTileMap(
	SpriteWorldPtr	spriteWorldP,
	TileMapPtr		*tileMapPtr,
	short 			numTileMapRows,
	short			numTileMapCols);

SW_FUNC void SWDisposeTileMap(
	SpriteWorldPtr spriteWorldP);

SW_FUNC OSErr SWResizeTileMap(
	SpriteWorldPtr	spriteWorldP,
	TileMapPtr		*tileMapPtr,
	short 			numNewTileMapRows,
	short			numNewTileMapCols);

SW_FUNC OSErr SWLoadTileMap(
	SpriteWorldPtr	spriteWorldP,
	TileMapPtr		*tileMapPtr,
	short 			resourceID);

SW_FUNC OSErr SWSaveTileMap(
	SpriteWorldPtr	spriteWorldP,
	short 			resourceID);

SW_FUNC void SWLockTiles(
	SpriteWorldPtr	spriteWorldP);

SW_FUNC void SWUnlockTiles(
	SpriteWorldPtr	spriteWorldP);

SW_FUNC void SWSetTilingOn(
	SpriteWorldPtr	spriteWorldP,
	Boolean			tilingIsOn);

SW_FUNC void SWSetSpriteUnderTiles(
	SpritePtr	srcSpriteP,
	Boolean		isUnder);

SW_FUNC OSErr SWSetTileMaskDrawProc(
	SpriteWorldPtr	spriteWorldP,
	DrawProcPtr		drawProc);

SW_FUNC OSErr SWLoadTileFromCicnResource(
	SpriteWorldPtr spriteWorldP, 
	short tileID,
	short cicnID, 
	MaskType maskType);

SW_FUNC OSErr SWLoadTilesFromPictResource(
	SpriteWorldPtr spriteWorldP, 
	short startTileID,
	short endTileID, 
	short pictResID, 
	short maskResID,
	MaskType maskType,
	short horizBorderWidth,
	short vertBorderHeight);

SW_FUNC void SWDisposeTile(
	SpriteWorldPtr	spriteWorldP,
	short tileID);

SW_FUNC OSErr SWDrawTilesInBackground(
	SpriteWorldPtr spriteWorldP);
	
SW_FUNC void SWResetTilingCache(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWDrawTile(
	SpriteWorldPtr spriteWorldP,
	short tileRow,
	short tileCol,
	short tileID);

SW_FUNC void SWSetTileChangeProc(
	SpriteWorldPtr spriteWorldP,
	TileChangeProcPtr tileChangeProc);

SW_FUNC void SWChangeTileImage(
	SpriteWorldPtr spriteWorldP,
	short tileID,
	short currentFrame);

SW_FUNC void SWUpdateTileOnScreen(
	SpriteWorldPtr spriteWorldP,
	short tileID);

SW_FUNC void SWResetCurrentTileImages(
	SpriteWorldPtr spriteWorldP);

SW_FUNC void SWDrawTilesInRect(
	SpriteWorldPtr spriteWorldP,
	Rect* updateRectP,
	Boolean faster);

SW_FUNC void SWDrawTilesAboveSprite(
	SpriteWorldPtr spriteWorldP,
	Rect* updateRectP);
	
SW_FUNC void SWWrapRectToWorkArea(
	SpriteWorldPtr spriteWorldP,
	Rect* dstRectP);


#ifdef __cplusplus
}
#endif

#endif /* __TILING__ */